Package: org.codehaus.groovy.control

## [Java] Class CompilerConfiguration

- org.codehaus.groovy.control.CompilerConfiguration

- Compilation control flags and coordination stuff.

  Authors:
    Chris Poirier
    Jochen Theodorou
    Jim White
    Cedric Champeau

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `static String[]` | `ALLOWED_JDKS` | An array of the valid targetBytecode values *
    `static int` | `ASM_API_VERSION` |
    `static String` | `CURRENT_JVM_VERSION` |
    `static CompilerConfiguration` | `DEFAULT` | A convenience for getting a default configuration.
    `static String` | `DEFAULT_SOURCE_ENCODING` | The default source encoding
    `static String` | `INVOKEDYNAMIC` | This (`"indy"`) is the Optimization Option value for enabling `invokedynamic` compilation.
    `static String` | `JDK10` | This (`"10"`) is the value for targetBytecode to compile for a JDK 10
    `static String` | `JDK11` | This (`"11"`) is the value for targetBytecode to compile for a JDK 11
    `static String` | `JDK12` | This (`"12"`) is the value for targetBytecode to compile for a JDK 12
    `static String` | `JDK4` | This (`"1.4"`) is the value for targetBytecode to compile for a JDK 1.4
    `static String` | `JDK5` | This (`"1.5"`) is the value for targetBytecode to compile for a JDK 1.5
    `static String` | `JDK6` | This (`"1.6"`) is the value for targetBytecode to compile for a JDK 1.6
    `static String` | `JDK7` | This (`"1.7"`) is the value for targetBytecode to compile for a JDK 1.7
    `static String` | `JDK8` | This (`"1.8"`) is the value for targetBytecode to compile for a JDK 1.8
    `static String` | `JDK9` | This (`"9"`) is the value for targetBytecode to compile for a JDK 9
    `static Map<String, Integer>` | `JDK_TO_BYTECODE_VERSION_MAP` | JDK version to bytecode version mapping
    `static String` | `POST_JDK5` | This constant is for comparing targetBytecode to ensure it is set to JDK 1.5 or later.
    `static String` | `PRE_JDK5` | This constant is for comparing targetBytecode to ensure it is set to an earlier value than JDK 1.5.

  - ### Properties Summary

    Properties
    Type | Name and description
    --- | ---
    `BytecodeProcessor` | `bytecodePostprocessor`
    `List<String>` | `classpath`
    `String` | `defaultScriptExtension`
    `Set<String>` | `disabledGlobalASTTransformations`
    `Map<String, Object>` | `jointCompilationOptions`
    `int` | `minimumRecompilationInterval`
    `Map<String, Boolean>` | `optimizationOptions`
    `PrintWriter` | `output`
    `ParserPluginFactory` | `pluginFactory`
    `String` | `scriptBaseClass`
    `Set<String>` | `scriptExtensions`
    `String` | `sourceEncoding`
    `String` | `targetBytecode`
    `File` | `targetDirectory`
    `File` | `targetDirectory`
    `int` | `tolerance`
    `int` | `warningLevel`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `CompilerConfiguration ()` Sets the Flags to defaults.
    `CompilerConfiguration (CompilerConfiguration configuration)` Copy constructor.
    `CompilerConfiguration (Properties configuration)` Sets the Flags to the specified configuration, with defaults for those not supplied.

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `CompilerConfiguration` | `addCompilationCustomizers(CompilationCustomizer... customizers)` Adds compilation customizers to the compilation process.
    `` | `void` | `configure(Properties configuration)` Method to configure a CompilerConfiguration by using Properties.
    `` | `BytecodeProcessor` | `getBytecodePostprocessor()`
    `` | `List<String>` | `getClasspath()` @return the classpath
    `` | `List<CompilationCustomizer>` | `getCompilationCustomizers()` Returns the list of compilation customizers.
    `` | `boolean` | `getDebug()` Returns true if debugging operation has been requested.
    `` | `String` | `getDefaultScriptExtension()`
    `` | `Set<String>` | `getDisabledGlobalASTTransformations()` Returns the list of disabled global AST transformation class names.
    `` | `Map<String, Object>` | `getJointCompilationOptions()` Gets the joint compilation options for this configuration.
    `` | `int` | `getMinimumRecompilationInterval()`
    `` | `Map<String, Boolean>` | `getOptimizationOptions()` Gets the optimization options for this configuration.
    `` | `PrintWriter` | `getOutput()` Gets the currently configured output writer.
    `` | `boolean` | `getParameters()` Returns true if parameter metadata generation has been enabled.
    `` | `ParserPluginFactory` | `getPluginFactory()`
    `` | `boolean` | `getRecompileGroovySource()`
    `` | `String` | `getScriptBaseClass()` Gets the name of the base class for scripts.
    `` | `Set<String>` | `getScriptExtensions()`
    `` | `String` | `getSourceEncoding()` Gets the currently configured source file encoding.
    `` | `String` | `getTargetBytecode()` Retrieves the compiler bytecode compatibility level.
    `` | `File` | `getTargetDirectory()` Gets the target directory for writing classes.
    `` | `int` | `getTolerance()` Returns the requested error tolerance.
    `` | `boolean` | `getVerbose()` Returns true if verbose operation has been requested.
    `` | `int` | `getWarningLevel()` Gets the currently configured warning level.
    `` | `boolean` | `isIndyEnabled()` Check whether invoke dynamic enabled
    `` | `static boolean` | `isPostJDK5(String bytecodeVersion)` Checks if the specified bytecode version string represents a JDK 1.5+ compatible bytecode version.
    `` | `static boolean` | `isPostJDK7(String bytecodeVersion)` Checks if the specified bytecode version string represents a JDK 1.7+ compatible bytecode version.
    `` | `static boolean` | `isPostJDK8(String bytecodeVersion)` Checks if the specified bytecode version string represents a JDK 1.8+ compatible bytecode version.
    `` | `static boolean` | `isPostJDK9(String bytecodeVersion)` Checks if the specified bytecode version string represents a JDK 1.8+ compatible bytecode version.
    `` | `void` | `setBytecodePostprocessor(BytecodeProcessor bytecodePostprocessor)`
    `` | `void` | `setClasspath(String classpath)` Sets the classpath.
    `` | `void` | `setClasspathList(List<String> parts)` sets the classpath using a list of Strings
    `` | `void` | `setDebug(boolean debug)` Turns debugging operation on or off.
    `` | `void` | `setDefaultScriptExtension(String defaultScriptExtension)`
    `` | `void` | `setDisabledGlobalASTTransformations(Set<String> disabledGlobalASTTransformations)` Disables the specified global AST transformations.
    `` | `void` | `setJointCompilationOptions(Map<String, Object> options)` Sets the joint compilation options for this configuration.
    `` | `void` | `setMinimumRecompilationInterval(int time)`
    `` | `void` | `setOptimizationOptions(Map<String, Boolean> options)` Sets the optimization options for this configuration.
    `` | `void` | `setOutput(PrintWriter output)` Sets the output writer.
    `` | `void` | `setParameters(boolean parameters)` Turns parameter metadata generation on or off.
    `` | `void` | `setPluginFactory(ParserPluginFactory pluginFactory)`
    `` | `void` | `setRecompileGroovySource(boolean recompile)`
    `` | `void` | `setScriptBaseClass(String scriptBaseClass)` Sets the name of the base class for scripts.
    `` | `void` | `setScriptExtensions(Set<String> scriptExtensions)`
    `` | `void` | `setSourceEncoding(String encoding)` Sets the encoding to be used when reading source files.
    `` | `void` | `setTargetBytecode(String version)` Allow setting the bytecode compatibility level.
    `` | `void` | `setTargetDirectory(String directory)` Sets the target directory.
    `` | `void` | `setTargetDirectory(File directory)` Sets the target directory.
    `` | `void` | `setTolerance(int tolerance)` Sets the error tolerance, which is the number of non-fatal errors (per unit) that should be tolerated before compilation is aborted.
    `` | `void` | `setVerbose(boolean verbose)` Turns verbose operation on or off.
    `` | `void` | `setWarningLevel(int level)` Sets the warning level.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Field Detail

    - #### public static final String[] ALLOWED_JDKS

      An array of the valid targetBytecode values *

    - #### public static final int ASM_API_VERSION

    - #### @Deprecated public static final String CURRENT_JVM_VERSION

    - #### public static final CompilerConfiguration DEFAULT

      A convenience for getting a default configuration. Do not modify it! See CompilerConfiguration(Properties) for an example on how to make a suitable copy to modify. But if you're really starting from a default context, then you probably just want `new CompilerConfiguration()`.

    - #### public static final String DEFAULT_SOURCE_ENCODING

      The default source encoding

    - #### public static final String INVOKEDYNAMIC

      This (`"indy"`) is the Optimization Option value for enabling `invokedynamic` compilation.

    - #### public static final String JDK10

      This (`"10"`) is the value for targetBytecode to compile for a JDK 10. *

    - #### public static final String JDK11

      This (`"11"`) is the value for targetBytecode to compile for a JDK 11. *

    - #### public static final String JDK12

      This (`"12"`) is the value for targetBytecode to compile for a JDK 12. *

    - #### public static final String JDK4

      This (`"1.4"`) is the value for targetBytecode to compile for a JDK 1.4. *

    - #### public static final String JDK5

      This (`"1.5"`) is the value for targetBytecode to compile for a JDK 1.5. *

    - #### public static final String JDK6

      This (`"1.6"`) is the value for targetBytecode to compile for a JDK 1.6. *

    - #### public static final String JDK7

      This (`"1.7"`) is the value for targetBytecode to compile for a JDK 1.7. *

    - #### public static final String JDK8

      This (`"1.8"`) is the value for targetBytecode to compile for a JDK 1.8. *

    - #### public static final String JDK9

      This (`"9"`) is the value for targetBytecode to compile for a JDK 9. *

    - #### public static final Map<String, Integer> JDK_TO_BYTECODE_VERSION_MAP

      JDK version to bytecode version mapping

    - #### @Deprecated public static final String POST_JDK5

      This constant is for comparing targetBytecode to ensure it is set to JDK 1.5 or later.

      deprecated:

    - #### @Deprecated public static final String PRE_JDK5

      This constant is for comparing targetBytecode to ensure it is set to an earlier value than JDK 1.5.

      deprecated:

  - ### Property Detail

    - #### BytecodeProcessor bytecodePostprocessor

    - #### List<String> classpath

    - #### String defaultScriptExtension

    - #### Set<String> disabledGlobalASTTransformations

    - #### Map<String, Object> jointCompilationOptions

    - #### int minimumRecompilationInterval

    - #### Map<String, Boolean> optimizationOptions

    - #### PrintWriter output

    - #### ParserPluginFactory pluginFactory

    - #### String scriptBaseClass

    - #### Set<String> scriptExtensions

    - #### String sourceEncoding

    - #### String targetBytecode

    - #### File targetDirectory

    - #### int tolerance

    - #### int warningLevel

  - ### Constructor Detail

    - #### public CompilerConfiguration()

      Sets the Flags to defaults.

    - #### public CompilerConfiguration(CompilerConfiguration configuration)

      Copy constructor. Use this if you have a mostly correct configuration for your compilation but you want to make a some changes programatically. An important reason to prefer this approach is that your code will most likely be forward compatible with future changes to this configuration API.

      An example of this copy constructor at work:

              // In all likelihood there is already a configuration in your code's context
              // for you to copy, but for the sake of this example we'll use the global default.
              CompilerConfiguration myConfiguration = new CompilerConfiguration(CompilerConfiguration.DEFAULT);
              myConfiguration.setDebug(true);

      Parameters:
        `configuration` - The configuration to copy.

    - #### public CompilerConfiguration(Properties configuration)

      Sets the Flags to the specified configuration, with defaults for those not supplied. Note that those "defaults" here do not include checking the settings in System.getProperties in general, only file.encoding, groovy.target.directory and groovy.source.encoding are.

      If you want to set a few flags but keep Groovy's default configuration behavior then be sure to make your settings in a Properties that is backed by `System.getProperties()` (which is done using this constructor). That might be done like this:

           Properties myProperties = new Properties(System.getProperties());
           myProperties.setProperty("groovy.output.debug", "true");
           myConfiguration = new CompilerConfiguration(myProperties);

      And you also have to contend with a possible SecurityException when getting the system properties (See System.getProperties). A safer approach would be to copy a default CompilerConfiguration and make your changes there using the setter:

           // In all likelihood there is already a configuration for you to copy,
           // but for the sake of this example we'll use the global default.
           CompilerConfiguration myConfiguration = new CompilerConfiguration(CompilerConfiguration.DEFAULT);
           myConfiguration.setDebug(true);

      Property Key | Get/Set Property Name
      --- | ---
      `"groovy.warnings"` | getWarningLevel
      `"groovy.source.encoding"` | getSourceEncoding
      `"groovy.target.directory"` | getTargetDirectory
      `"groovy.target.bytecode"` | getTargetBytecode
      `"groovy.classpath"` | getClasspath
      `"groovy.output.verbose"` | getVerbose
      `"groovy.output.debug"` | getDebug
      `"groovy.errors.tolerance"` | getTolerance
      `"groovy.script.extension"` | getDefaultScriptExtension
      `"groovy.script.base"` | getScriptBaseClass
      `"groovy.recompile"` | getRecompileGroovySource
      `"groovy.recompile.minimumInterval"` | getMinimumRecompilationInterval

      Parameters:
        `configuration` - The properties to get flag values from.

  - ### Method Detail

    - #### public CompilerConfiguration addCompilationCustomizers(CompilationCustomizer... customizers)

      Adds compilation customizers to the compilation process. A compilation customizer is a class node operation which performs various operations going from adding imports to access control.

      Parameters:
        `customizers` - the list of customizers to be added
      Returns:
        this configuration instance

    - #### public void configure(Properties configuration)

      Method to configure a CompilerConfiguration by using Properties. For a list of available properties look at CompilerConfiguration(Properties).

      Parameters:
        `configuration` - The properties to get flag values from.

    - #### public BytecodeProcessor getBytecodePostprocessor()

    - #### public List<String> getClasspath()

      Returns:
        the classpath

    - #### public List<CompilationCustomizer> getCompilationCustomizers()

      Returns the list of compilation customizers.

      Returns:
        the customizers (always not null)

    - #### public boolean getDebug()

      Returns true if debugging operation has been requested.

    - #### public String getDefaultScriptExtension()

    - #### public Set<String> getDisabledGlobalASTTransformations()

      Returns the list of disabled global AST transformation class names.

      Returns:
        a list of global AST transformation fully qualified class names

    - #### public Map<String, Object> getJointCompilationOptions()

      Gets the joint compilation options for this configuration.

      Returns:
        the options

    - #### public int getMinimumRecompilationInterval()

    - #### public Map<String, Boolean> getOptimizationOptions()

      Gets the optimization options for this configuration.

      Returns:
        the options (always not null)

    - #### @Deprecated public PrintWriter getOutput()

      Gets the currently configured output writer.

      deprecated:
        not used anymore

    - #### public boolean getParameters()

      Returns true if parameter metadata generation has been enabled.

    - #### public ParserPluginFactory getPluginFactory()

    - #### public boolean getRecompileGroovySource()

    - #### public String getScriptBaseClass()

      Gets the name of the base class for scripts. It must be a subclass of Script.

    - #### public Set<String> getScriptExtensions()

    - #### public String getSourceEncoding()

      Gets the currently configured source file encoding.

    - #### public String getTargetBytecode()

      Retrieves the compiler bytecode compatibility level. Defaults to the minimum officially supported bytecode version for any particular Groovy version.

      Returns:
        bytecode compatibility level

    - #### public File getTargetDirectory()

      Gets the target directory for writing classes.

    - #### public int getTolerance()

      Returns the requested error tolerance.

    - #### public boolean getVerbose()

      Returns true if verbose operation has been requested.

    - #### public int getWarningLevel()

      Gets the currently configured warning level. See WarningMessage for level details.

    - #### public boolean isIndyEnabled()

      Check whether invoke dynamic enabled

      Returns:
        the result

    - #### public static boolean isPostJDK5(String bytecodeVersion)

      Checks if the specified bytecode version string represents a JDK 1.5+ compatible bytecode version.

      Parameters:
        `bytecodeVersion` - The parameter can take one of the values in ALLOWED_JDKS.
      Returns:
        true if the bytecode version is JDK 1.5+

    - #### public static boolean isPostJDK7(String bytecodeVersion)

      Checks if the specified bytecode version string represents a JDK 1.7+ compatible bytecode version.

      Parameters:
        `bytecodeVersion` - The parameter can take one of the values in ALLOWED_JDKS.
      Returns:
        true if the bytecode version is JDK 1.7+

    - #### public static boolean isPostJDK8(String bytecodeVersion)

      Checks if the specified bytecode version string represents a JDK 1.8+ compatible bytecode version.

      Parameters:
        `bytecodeVersion` - The parameter can take one of the values in ALLOWED_JDKS.
      Returns:
        true if the bytecode version is JDK 1.8+

    - #### public static boolean isPostJDK9(String bytecodeVersion)

      Checks if the specified bytecode version string represents a JDK 1.8+ compatible bytecode version.

      Parameters:
        `bytecodeVersion` - The parameter can take one of the values in ALLOWED_JDKS.
      Returns:
        true if the bytecode version is JDK 9.0+

    - #### public void setBytecodePostprocessor(BytecodeProcessor bytecodePostprocessor)

    - #### public void setClasspath(String classpath)

      Sets the classpath.

    - #### public void setClasspathList(List<String> parts)

      sets the classpath using a list of Strings

      Parameters:
        `parts` - list of strings containing the classpath parts

    - #### public void setDebug(boolean debug)

      Turns debugging operation on or off.

    - #### public void setDefaultScriptExtension(String defaultScriptExtension)

    - #### public void setDisabledGlobalASTTransformations(Set<String> disabledGlobalASTTransformations)

      Disables the specified global AST transformations. In order to avoid class loading side effects, it is not recommended to use MyASTTransformation.class.getName() by directly use the class name as a string. Disabled AST transformations only apply to automatically loaded global AST transformations, that is to say transformations defined in a META-INF/services/org.codehaus.groovy.transform.ASTTransformation file. If you explicitly add a global AST transformation in your compilation process, for example using the ASTTransformationCustomizer or using a org.codehaus.groovy.control.CompilationUnit.PrimaryClassNodeOperation, then nothing will prevent the transformation from being loaded.

      Parameters:
        `disabledGlobalASTTransformations` - a set of fully qualified class names of global AST transformations which should not be loaded.

    - #### public void setJointCompilationOptions(Map<String, Object> options)

      Sets the joint compilation options for this configuration. Using null will disable joint compilation.

      Parameters:
        `options` - the options

    - #### public void setMinimumRecompilationInterval(int time)

    - #### public void setOptimizationOptions(Map<String, Boolean> options)

      Sets the optimization options for this configuration. No entry or a true for that entry means to enable that optimization, a false means the optimization is disabled. Valid keys are "all" and "int".

      throws:
        IllegalArgumentException if the options are null
      Parameters:
        `options` - the options.

    - #### @Deprecated public void setOutput(PrintWriter output)

      Sets the output writer.

      deprecated:
        not used anymore, has no effect

    - #### public void setParameters(boolean parameters)

      Turns parameter metadata generation on or off.

    - #### public void setPluginFactory(ParserPluginFactory pluginFactory)

    - #### public void setRecompileGroovySource(boolean recompile)

    - #### public void setScriptBaseClass(String scriptBaseClass)

      Sets the name of the base class for scripts. It must be a subclass of Script.

    - #### public void setScriptExtensions(Set<String> scriptExtensions)

    - #### public void setSourceEncoding(String encoding)

      Sets the encoding to be used when reading source files.

    - #### public void setTargetBytecode(String version)

      Allow setting the bytecode compatibility level. The parameter can take one of the values in ALLOWED_JDKS.

      Parameters:
        `version` - the bytecode compatibility level

    - #### public void setTargetDirectory(String directory)

      Sets the target directory.

    - #### public void setTargetDirectory(File directory)

      Sets the target directory.

    - #### public void setTolerance(int tolerance)

      Sets the error tolerance, which is the number of non-fatal errors (per unit) that should be tolerated before compilation is aborted.

    - #### public void setVerbose(boolean verbose)

      Turns verbose operation on or off.

    - #### public void setWarningLevel(int level)

      Sets the warning level. See WarningMessage for level details.